Subject: Re: [PATCH] powerpc: Disable external interrupts in bootwrapper

From: Segher Boessenkool <[email-masked]>
Date: Wed, 28 Mar 2007 18:52:33 +0200

>>>> Disable external interrupts very early in the bootwrapper in case
>>>> the firmware left a device generating interrupts.
>>>
>>> Sounds reasonable, except that I wonder if systems running under a
>>> real OF want to do this...
>>
>> I don't know.  Would someone who knows OF speak up?
>
> OF isn't supposed to use external interrupts

That isn't a hard rule.  But yeah, hardly any OF
will ever use interrupts for normal operation --
the kernel can have taken control of the exception
vector and still want to access devices via OF, for
example.

> but I wouldn't bet on what
> Apple's one does... I think it's not safe to do that thus on OF based
> platforms.

Until you take control of the external interrupt and
decrementer interrupt (and overtemp interrupt, on
some CPUs), you really shouldn't turn off the EE bit
for extended periods of time.

Set EE=0 right before the earliest of a) you want OF
to be dead dead dead; or b) you copy the kernel's
exception vectors to 0; and all will be fine.

Segher